# Summary

* [PHP](README.md)
    * [语言参考](docs/语言参考.md)
        * [基本语法](docs/语言参考/基本语法.md)
            * [PHP 标记](docs/语言参考/基本语法/PHP 标记.md)
            * [从 HTML 中分离](docs/语言参考/基本语法/从 HTML 中分离.md)
            * [指令分隔符](docs/语言参考/基本语法/指令分隔符.md)
            * [注释](docs/语言参考/基本语法/注释.md)
        * [类型](docs/语言参考/类型.md)
            * [Boolean 布尔类型](docs/语言参考/类型/Boolean 布尔类型.md)
            * [Integer 整型](docs/语言参考/类型/Integer 整型.md)
            * [Float 浮点型](docs/语言参考/类型/Float 浮点型.md)
            * [String 字符串](docs/语言参考/类型/String 字符串.md)
            * [Array 数组](docs/语言参考/类型/Array 数组.md)
            * [Object 对象](docs/语言参考/类型/Object 对象.md)
            * [Resource 资源类型](docs/语言参考/类型/Resource 资源类型.md)
            * [NULL](docs/语言参考/类型/NULL.md)
            * [Callable 可调用类型](docs/语言参考/类型/Callable 可调用类型.md)
            * [类型转换的判别](docs/语言参考/类型/类型转换的判别.md)
        * [变量](docs/语言参考/变量.md)
            * [基本语法](docs/语言参考/变量/基本语法.md)
            * [变量范围](docs/语言参考/变量/变量范围.md)
            * [可变变量](docs/语言参考/变量/可变变量.md)
            * [来自 PHP 之外的变量](docs/语言参考/变量/来自 PHP 之外的变量.md)
        * [常量](docs/语言参考/常量.md)
            * [基本语法](docs/语言参考/常量/基本语法.md)
            * [魔术常量](docs/语言参考/常量/魔术常量.md)
        * [表达式](docs/语言参考/表达式.md)
        * [运算符](docs/语言参考/运算符.md)
            * [运算符优先级](docs/语言参考/运算符/运算符优先级.md)
            * [算数运算符](docs/语言参考/运算符/算数运算符.md)
            * [赋值运算符](docs/语言参考/运算符/赋值运算符.md)
            * [位运算符](docs/语言参考/运算符/位运算符.md)
            * [比较运算符](docs/语言参考/运算符/比较运算符.md)
            * [错误控制运算符](docs/语言参考/运算符/错误控制运算符.md)
            * [执行运算符](docs/语言参考/运算符/执行运算符.md)
            * [递增递减运算符](docs/语言参考/运算符/递增递减运算符.md)
            * [逻辑运算符](docs/语言参考/运算符/逻辑运算符.md)
            * [字符串运算符](docs/语言参考/运算符/字符串运算符.md)
            * [数组运算符](docs/语言参考/运算符/数组运算符.md)
            * [类型运算符](docs/语言参考/运算符/类型运算符.md)
        * [流程控制](docs/语言参考/流程控制.md)
            * [if](docs/语言参考/流程控制/if.md)
            * [else](docs/语言参考/流程控制/else.md)
            * [elseif](docs/语言参考/流程控制/elseif.md)
            * [while](docs/语言参考/流程控制/while.md)
            * [do-while](docs/语言参考/流程控制/do-while.md)
            * [for](docs/语言参考/流程控制/for.md)
            * [foreach](docs/语言参考/流程控制/foreach.md)
            * [switch](docs/语言参考/流程控制/switch.md)
            * [break](docs/语言参考/流程控制/break.md)
            * [continue](docs/语言参考/流程控制/continue.md)
            * [流程控制的替代语法](docs/语言参考/流程控制/流程控制的替代语法.md)
            * [declare](docs/语言参考/流程控制/declare.md)
            * [return](docs/语言参考/流程控制/return.md)
            * [require](docs/语言参考/流程控制/require.md)
            * [include](docs/语言参考/流程控制/include.md)
            * [require_once](docs/语言参考/流程控制/require_once.md)
            * [include_once](docs/语言参考/流程控制/include_once.md)
            * [goto](docs/语言参考/流程控制/goto.md)
        * [函数](docs/语言参考/函数.md)
            * [用户自定义函数](docs/语言参考/函数/用户自定义函数.md)
            * [函数的参数](docs/语言参考/函数/函数的参数.md)
            * [返回值](docs/语言参考/函数/返回值.md)
            * [可变函数](docs/语言参考/函数/可变函数.md)
            * [匿名函数](docs/语言参考/函数/匿名函数.md)
        * [类与对象](docs/语言参考/类与对象.md)
            * [基本语法](docs/语言参考/类与对象/基本语法.md)
            * [属性](docs/语言参考/类与对象/属性.md)
            * [类常量](docs/语言参考/类与对象/类常量.md)
            * [类的自动加载](docs/语言参考/类与对象/类的自动加载.md)
            * [构造函数和析构函数](docs/语言参考/类与对象/构造函数和析构函数.md)
            * [访问控制](docs/语言参考/类与对象/访问控制.md)
            * [对象继承](docs/语言参考/类与对象/对象继承.md)
            * [范围解析操作符](docs/语言参考/类与对象/范围解析操作符.md)
            * [Static 关键字](docs/语言参考/类与对象/Static 关键字.md)
            * [抽象类](docs/语言参考/类与对象/抽象类.md)
            * [对象接口](docs/语言参考/类与对象/对象接口.md)
            * [Trait](docs/语言参考/类与对象/Trait.md)
            * [匿名类](docs/语言参考/类与对象/匿名类.md)
            * [重载](docs/语言参考/类与对象/重载.md)
            * [遍历对象](docs/语言参考/类与对象/遍历对象.md)
            * [魔术方法](docs/语言参考/类与对象/魔术方法.md)
            * [Final 关键字](docs/语言参考/类与对象/Final 关键字.md)
            * [对象复制](docs/语言参考/类与对象/对象复制.md)
            * [对象比较](docs/语言参考/类与对象/对象比较.md)
            * [类型约束](docs/语言参考/类与对象/类型约束.md)
            * [后期静态绑定](docs/语言参考/类与对象/后期静态绑定.md)
            * [对象和引用](docs/语言参考/类与对象/对象和引用.md)
            * [对象序列化](docs/语言参考/类与对象/对象序列化.md)
        * [命名空间](docs/语言参考/命名空间.md)
            * [基本语法](docs/语言参考/命名空间/基本语法.md)
            * [定义子命名空间](docs/语言参考/命名空间/定义子命名空间.md)
            * [在同一个文件中定义多个命名空间](docs/语言参考/命名空间/在同一个文件中定义多个命名空间.md)
            * [使用命名空间 - 基础](docs/语言参考/命名空间/使用命名空间 - 基础.md)
            * [命名空间和动态语言特征](docs/语言参考/命名空间/命名空间和动态语言特征.md)
            * [namespace 关键字和 \_\_NAMESPACE\_\_ 魔术常量](docs/语言参考/命名空间/namespace 关键字和 __NAMESPACE__ 魔术常量.md)
            * [使用命名空间 - 别名和导入](docs/语言参考/命名空间/使用命名空间 - 别名和导入.md)
            * [全局空间](docs/语言参考/命名空间/全局空间.md)
            * [使用命名空间 - 后备全局函数和常量](docs/语言参考/命名空间/使用命名空间 - 后备全局函数和常量.md)
            * [名称解析规则](docs/语言参考/命名空间/名称解析规则.md)
        * [Errors](docs/语言参考/Errors.md)
        * [异常处理](docs/语言参考/异常处理.md)
            * [基本语法](docs/语言参考/异常处理/基本语法.md)
            * [扩展 PHP 内置的异常处理类](docs/语言参考/异常处理/扩展 PHP 内置的异常处理类.md)
        * [生成器](docs/语言参考/生成器.md)
            * [生成器总览](docs/语言参考/生成器/生成器总览.md)
            * [生成器语法](docs/语言参考/生成器/生成器语法.md)
            * [生成器与 Iterator 对象比较](docs/语言参考/生成器/生成器与 Iterator 对象比较.md)
        * [引用的解释](docs/语言参考/引用的解释.md)
            * [引用是什么](docs/语言参考/引用的解释/引用是什么.md)
            * [引用不是什么](docs/语言参考/引用的解释/引用不是什么.md)
            * [引用做什么](docs/语言参考/引用的解释/引用做什么.md)
            * [引用传递](docs/语言参考/引用的解释/引用传递.md)
            * [引用返回](docs/语言参考/引用的解释/引用返回.md)
            * [取消引用](docs/语言参考/引用的解释/取消引用.md)
            * [引用定位](docs/语言参考/引用的解释/引用定位.md)
        * [预定义变量](docs/语言参考/预定义变量.md)
            * [超全局变量](docs/语言参考/预定义变量/超全局变量.md)
            * [$GLOBALS](docs/语言参考/预定义变量/$GLOBALS.md)
            * [$_GET](docs/语言参考/预定义变量/$_GET.md)
            * [$_POST](docs/语言参考/预定义变量/$_POST.md)
            * [$_COOKIE](docs/语言参考/预定义变量/$_COOKIE.md)
            * [$_REQUEST](docs/语言参考/预定义变量/$_REQUEST.md)
            * [$_FILES](docs/语言参考/预定义变量/$_FILES.md)
            * [$_SESSION](docs/语言参考/预定义变量/$_SESSION.md)
            * [$_SERVER](docs/语言参考/预定义变量/$_SERVER.md)
            * [$_ENV](docs/语言参考/预定义变量/$_ENV.md)
            * [$http_response_header](docs/语言参考/预定义变量/$http_response_header.md)
            * [$argc](docs/语言参考/预定义变量/$argc.md)
            * [$argv](docs/语言参考/预定义变量/$argv.md)
        * [预定义异常](docs/语言参考/预定义异常.md)
            * [Exception](docs/语言参考/预定义异常/Exception.md)
            * [ErrorException](docs/语言参考/预定义异常/ErrorException.md)
        * [预定义接口](docs/语言参考/预定义接口.md)
            * [Traversable](docs/语言参考/预定义接口/Traversable.md)
            * [Iterator](docs/语言参考/预定义接口/Iterator.md)
            * [IteratorAggregate](docs/语言参考/预定义接口/IteratorAggregate.md)
            * [ArrayAccess](docs/语言参考/预定义接口/ArrayAccess.md)
            * [Serializable](docs/语言参考/预定义接口/Serializable.md)
            * [Closure](docs/语言参考/预定义接口/Closure.md)
            * [Generator](docs/语言参考/预定义接口/Generator.md)
        * [上下文选项和参数](docs/语言参考/上下文选项和参数.md)
            * [套接字上下文选项](docs/语言参考/上下文选项和参数/套接字上下文选项.md)
            * [HTTP 上下文选项](docs/语言参考/上下文选项和参数/HTTP 上下文选项.md)
            * [FTP 上下文选项](docs/语言参考/上下文选项和参数/FTP 上下文选项.md)
            * [SSL 上下文选项](docs/语言参考/上下文选项和参数/SSL 上下文选项.md)
            * [CURL 上下文选项](docs/语言参考/上下文选项和参数/CURL 上下文选项.md)
            * [Phar 上下文选项](docs/语言参考/上下文选项和参数/Phar 上下文选项.md)
            * [MongoDB 上下文选项](docs/语言参考/上下文选项和参数/MongoDB 上下文选项.md)
            * [Context 参数](docs/语言参考/上下文选项和参数/Context 参数.md)
        * [支持的协议和封装协议](docs/语言参考/支持的协议和封装协议.md)
            * [file://](docs/语言参考/支持的协议和封装协议/file.md)
            * [http://](docs/语言参考/支持的协议和封装协议/http.md)
            * [ftp://](docs/语言参考/支持的协议和封装协议/ftp.md)
            * [php://](docs/语言参考/支持的协议和封装协议/php.md)
            * [zlib://](docs/语言参考/支持的协议和封装协议/zlib.md)
            * [data://](docs/语言参考/支持的协议和封装协议/data.md)
            * [global://](docs/语言参考/支持的协议和封装协议/global.md)
            * [phar://](docs/语言参考/支持的协议和封装协议/phar.md)
            * [ssh2://](docs/语言参考/支持的协议和封装协议/ssh2.md)
            * [rar://](docs/语言参考/支持的协议和封装协议/rar.md)
            * [ogg://](docs/语言参考/支持的协议和封装协议/ogg.md)
            * [expect://](docs/语言参考/支持的协议和封装协议/expect.md)
    * [函数参考](docs/函数参考.md)
        * [影响 PHP 行为的扩展](docs/函数参考/影响 PHP 行为的扩展.md)
            * [错误处理和日志记录](docs/函数参考/影响 PHP 行为的扩展/错误处理和日志记录.md)
            * [输出缓冲控制](docs/函数参考/影响 PHP 行为的扩展/输出缓冲控制.md)
            * [PHP 选项和信息](docs/函数参考/影响 PHP 行为的扩展/PHP 选项和信息.md)
        * [加密扩展](docs/函数参考/加密扩展.md)
            * [Hash](docs/函数参考/加密扩展/Hash.md)
            * [OpenSSL](docs/函数参考/加密扩展/OpenSSL.md)
            * [密码散列算法](docs/函数参考/加密扩展/密码散列算法.md)
        * [数据库扩展](docs/函数参考/数据库扩展.md)
            * [数据库抽象层](docs/函数参考/数据库扩展/数据库抽象层.md)
                * [PDO](docs/函数参考/数据库扩展/数据库抽象层/PDO.md)
        * [日期与时间相关扩展](docs/函数参考/日期与时间相关扩展.md)
            * [日期与时间](docs/函数参考/日期与时间相关扩展/日期与时间.md)
        * [文件系统相关扩展](docs/函数参考/文件系统相关扩展.md)
            * [目录](docs/函数参考/文件系统相关扩展/目录.md)
            * [文件系统](docs/函数参考/文件系统相关扩展/文件系统.md)
        * [国际化与字符编码支持](docs/函数参考/国际化与字符编码支持.md)
            * [iconv](docs/函数参考/国际化与字符编码支持/iconv.md)
            * [多字节字符串](docs/函数参考/国际化与字符编码支持/多字节字符串.md)
        * [图像生成和处理](docs/函数参考/图像生成和处理.md)
            * [GD](docs/函数参考/图像生成和处理/GD.md)
        * [邮件相关扩展](docs/函数参考/邮件相关扩展.md)
            * [邮件](docs/函数参考/邮件相关扩展/邮件.md)
        * [数学扩展](docs/函数参考/数学扩展.md)
            * [任意精度数学](docs/函数参考/数学扩展/任意精度数学.md)
            * [数学](docs/函数参考/数学扩展/数学.md)
        * [进程控制扩展](docs/函数参考/进程控制扩展.md)
            * [程序执行](docs/函数参考/进程控制扩展/程序执行.md)
        * [其他基本扩展](docs/函数参考/其他基本扩展.md)
            * [JSON](docs/函数参考/其他基本扩展/JSON.md)
            * [杂项](docs/函数参考/其他基本扩展/杂项.md)
            * [PHP 标准库](docs/函数参考/其他基本扩展/PHP 标准库.md)
            * [Streams](docs/函数参考/其他基本扩展/Streams.md)
            * [Tokenizer](docs/函数参考/其他基本扩展/Tokenizer.md)
            * [URL](docs/函数参考/其他基本扩展/URL.md)
        * [其他服务](docs/函数参考/其他服务.md)
            * [cURL](docs/函数参考/其他服务/cURL.md)
            * [网络](docs/函数参考/其他服务/网络.md)
            * [Sockets](docs/函数参考/其他服务/Sockets.md)
        * [Session 扩展](docs/函数参考/Session 扩展.md)
            * [Session](docs/函数参考/Session 扩展/Session.md)
        * [文本处理](docs/函数参考/文本处理.md)
            * [正则表达式](docs/函数参考/文本处理/正则表达式.md)
            * [字符串](docs/函数参考/文本处理/字符串.md)
        * [变量与类型相关扩展](docs/函数参考/变量与类型相关扩展.md)
            * [数组](docs/函数参考/变量与类型相关扩展/数组.md)
            * [类与对象](docs/函数参考/变量与类型相关扩展/类与对象.md)
            * [字符类型检测](docs/函数参考/变量与类型相关扩展/字符类型检测.md)
            * [过滤器](docs/函数参考/变量与类型相关扩展/过滤器.md)
            * [函数处理](docs/函数参考/变量与类型相关扩展/函数处理.md)
            * [反射](docs/函数参考/变量与类型相关扩展/反射.md)
            * [变量](docs/函数参考/变量与类型相关扩展/变量.md)
        * [XML 操作](docs/函数参考/XML 操作.md)
            * [SimpleXML](docs/函数参考/XML 操作/SimpleXML.md)
            * [XML 解析器](docs/函数参考/XML 操作/XML 解析器.md)
    * [会话和安全](docs/会话和安全.md)
        * [会话管理基础](docs/会话和安全/会话管理基础.md)
        * [和会话安全相关的配置项](docs/会话和安全/和会话安全相关的配置项.md)
    * [PHP 的命令行模式](docs/PHP 的命令行模式.md)
        * [内置的 Web 服务器](docs/PHP 的命令行模式/内置的 Web 服务器.md)
        * [和命令行模式相关的配置项](docs/PHP 的命令行模式/和命令行模式相关的配置项.md)
    * [垃圾回收机制](docs/垃圾回收机制.md)
    * [PHP 类型比较表](docs/PHP 类型比较表.md)
    * [PSR](docs/PSR.md)
        * [PSR-1 基础编码规范](docs/PSR/PSR-1 基础编码规范.md)
        * [PSR-4 自动加载规范](docs/PSR/PSR-4 自动加载规范.md)
        * [PSR-12 编码规范扩充](docs/PSR/PSR-12 编码规范扩充.md)

