# 数学

* [abs - 绝对值](#abs)
* [acos - 反余弦](#acos)
* [acosh - 反双曲余弦](#acosh)
* [asin - 反正弦](#asin)
* [asinh - 反双曲正弦](#asinh)
* [atan2 - 两个参数的反正切](#atan2)
* [atan - 反正切](#atan)
* [atanh - 反双曲正切](#atanh)
* [base_convert - 在任意进制之间转换数字](#baseconvert)
* [bindec - 二进制转换为十进制](#bindec)
* [ceil - 向上取整](#ceil)
* [cos - 余弦](#cos)
* [cosh - 双曲余弦](#cosh)
* [decbin - 十进制转换为二进制](#decbin)
* [dechex - 十进制转换为十六进制](#dechex)
* [decoct - 十进制转换为八进制](#decoct)
* [deg2rad - 将角度转换为弧度](#deg2rad)
* [exp - 计算 e 的指数](#exp)
* [expm1 - 返回 exp(number) - 1 ，甚至当 number 的值接近零也能计算出准确结果](#expm1)
* [floor - 向下取整](#floor)
* [fmod - 返回除法的浮点数余数](#fmod)
* [getrandmax - 获取随机数最大的可能值](#getrandmax)
* [hexdec - 十六进制转换为十进制](#hexdec)
* [hypot - 计算直角三角形的斜边长度](#hypot)
* [intdiv - 对除法结果取整](#intdiv)
* [is_finite - 判断是否为有限值](#isfinite)
* [is_infinite - 判断是否为无限值](#isinfinite)
* [is_nan - 判断是否为合法数值](#isnan)
* [lcg_value - 组合线性同余发生器](#lcgvalue)
* [log10 - 以 10 为底的对数](#log10)
* [log1p - 返回 log(1 + number) ，甚至当 number 的值接近零也能计算出准确结果](#log1p)
* [log - 自然对数](#log)
* [max - 找出最大值](#max)
* [min - 找出最小值](#min)
* [mt_getrandmax - 获取随机数最大的可能值](#mtgetrandmax)
* [mt_rand - 生成更好的随机数](#mtrand)
* [mt_srand - 播下一个更好的随机数发生器种子](#mtsrand)
* [octdec - 八进制转换为十进制](#octdec)
* [pi - 获取圆周率值](#pi)
* [pow - 指数表达式](#pow)
* [rad2deg - 将弧度转换为角度](#rad2deg)
* [rand - 产生一个随机整数](#rand)
* [round - 对浮点数进行四舍五入](#round)
* [sin - 正弦](#sin)
* [sinh - 双曲正弦](#sinh)
* [sqrt - 平方根](#sqrt)
* [srand - 播下随机数发生器种子](#srand)
* [tan - 正切](#tan)
* [tanh - 双曲正切](#tanh)

## abs

```php
<?php

var_dump(abs(-4.2)); // float(4.2)
var_dump(abs(0));    // int(0)
var_dump(abs(5));    // int(5)

```

## acos

```php
<?php

var_dump(acos(-1)); // float(3.1415926535898)
var_dump(acos(0));  // float(1.5707963267949)
var_dump(acos(1));  // float(0)

```

## acosh

```php
<?php

var_dump(acosh(1));  // float(0)
var_dump(acosh(10)); // float(2.9932228461264)
var_dump(acosh(20)); // float(3.6882538673613)

```

## asin

```php
<?php

var_dump(asin(-1)); // float(-1.5707963267949)
var_dump(asin(0));  // float(0)
var_dump(asin(1));  // float(1.5707963267949)

```

## asinh

```php
<?php

var_dump(asinh(-1)); // float(-0.88137358701954)
var_dump(asinh(0));  // float(0)
var_dump(asinh(1));  // float(0.88137358701954)

```

## atan2

```php
<?php

var_dump(atan2(-1, -1)); // float(-2.3561944901923)
var_dump(atan2(1, 1));   // float(0.78539816339745)
var_dump(atan2(10, 20)); // float(0.46364760900081)

```

## atan

```php
<?php

var_dump(atan(-1)); // float(-0.78539816339745)
var_dump(atan(0));  // float(0)
var_dump(atan(1));  // float(0.78539816339745)

```

## atanh

```php
<?php

var_dump(atanh(-0.5)); // float(-0.54930614433405)
var_dump(atanh(0));    // float(0)
var_dump(atanh(0.5));  // float(0.54930614433405)

```

## base_convert

```php
<?php

var_dump(base_convert('11', 2, 10));     // string(1) "3"
var_dump(base_convert('0031', 8, 10));   // string(2) "25"
var_dump(base_convert('A37334', 16, 2)); // string(24) "101000110111001100110100"

```

## bindec

```php
<?php

var_dump(bindec('11'));     // int(3)
var_dump(bindec('110011')); // int(51)
var_dump(bindec('111111')); // int(63)

```

## ceil

```php
<?php

var_dump(ceil(-3.14)); // float(-3)
var_dump(ceil(4.3));   // float(5)
var_dump(ceil(9.999)); // float(10)

```

## cos

```php
<?php

var_dump(cos(-1)); // float(0.54030230586814)
var_dump(cos(0));  // float(1)
var_dump(cos(1));  // float(0.54030230586814)

```

## cosh

```php
<?php

var_dump(cosh(-1)); // float(1.5430806348152)
var_dump(cosh(0));  // float(1)
var_dump(cosh(1));  // float(1.5430806348152)

```

## decbin

```php
<?php

var_dump(decbin(11)); // string(4) "1011"
var_dump(decbin(12)); // string(4) "1100"
var_dump(decbin(26)); // string(5) "11010"

```

## dechex

```php
<?php

var_dump(dechex(10));  // string(1) "a"
var_dump(dechex(47));  // string(2) "2f"
var_dump(dechex(100)); // string(2) "64"

```

## decoct

```php
<?php

var_dump(decoct(15));  // string(2) "17"
var_dump(decoct(100)); // string(3) "144"
var_dump(decoct(264)); // string(3) "410"

```

## deg2rad

```php
<?php

var_dump(deg2rad(30));  // float(0.5235987755983)
var_dump(deg2rad(90));  // float(1.5707963267949)
var_dump(deg2rad(180)); // float(3.1415926535898)

```

## exp

```php
<?php

var_dump(exp(0));   // float(1)
var_dump(exp(5.7)); // float(298.86740096706)
var_dump(exp(12));  // float(162754.791419)

```

## expm1

```php
<?php

var_dump(expm1(0));   // float(0)
var_dump(expm1(5.7)); // float(297.86740096706)
var_dump(expm1(12));  // float(162753.791419)

```

## floor

```php
<?php

var_dump(floor(-3.14)); // float(-4)
var_dump(floor(4.3));   // float(4)
var_dump(floor(9.999)); // float(9)

```

## fmod

```php
<?php

var_dump(fmod(-10, 3));   // float(-1)
var_dump(fmod(5, 2));     // float(1)
var_dump(fmod(5.7, 1.3)); // float(0.5)

```

## getrandmax

```php
<?php

var_dump(getrandmax());

```

## hexdec

```php
<?php

var_dump(hexdec('a'));  // int(10)
var_dump(hexdec('a0')); // int(160)
var_dump(hexdec('ee')); // int(238)

```

## hypot

```php
<?php

var_dump(hypot(1, 2)); // float(2.2360679774998)
var_dump(hypot(2, 3)); // float(3.605551275464)
var_dump(hypot(3, 4)); // float(5)

```

## intdiv

```php
<?php

var_dump(intdiv(-3, -2)); // int(1)
var_dump(intdiv(-3, 2));  // int(-1)
var_dump(intdiv(3, 2));   // int(1)

```

## is_finite

```php
<?php

var_dump(is_finite(log(0))); // bool(false)
var_dump(is_finite(2));      // bool(true)
var_dump(is_finite(100));    // bool(true)

```

## is_infinite

```php
<?php

var_dump(is_infinite(log(0))); // bool(true)
var_dump(is_infinite(2));      // bool(false)
var_dump(is_infinite(100));    // bool(false)

```

## is_nan

```php
<?php

var_dump(is_nan(acos(8))); // bool(true)
var_dump(is_nan(0));       // bool(false)
var_dump(is_nan(1));       // bool(false)

```

## lcg_value

```php
<?php

var_dump(lcg_value());

```

## log10

```php
<?php

var_dump(log10(1));      // float(0)
var_dump(log10(2));      // float(0.30102999566398)
var_dump(log10(2.7183)); // float(0.43429738512451)

```

## log1p

```php
<?php

var_dump(log1p(0)); // float(0)
var_dump(log1p(1)); // float(0.69314718055995)
var_dump(log1p(2)); // float(1.0986122886681)

```

## log

```php
<?php

var_dump(log(1));    // float(0)
var_dump(log(1, 2)); // float(0)
var_dump(log(2, 2)); // float(1)

```

## max

```php
<?php

var_dump(max(1, 3, 5, 6, 7));           // int(7)
var_dump(max([2, 4, 5]));               // int(5)
var_dump(max('hello', 0));              // string(5) "hello"
var_dump(max(0, 'hello'));              // int(0)
var_dump(max('42', 3));                 // string(2) "42"
var_dump(max([2, 4, 8], [2, 5, 7]));    // array(3) { [0]=> int(2) [1]=> int(5) [2]=> int(7) }
var_dump(max([2, 2, 2], [1, 1, 1, 1])); // array(4) { [0]=> int(1) [1]=> int(1) [2]=> int(1) [3]=> int(1) }
var_dump(max('hello', [2, 5, 7], 42));  // array(3) { [0]=> int(2) [1]=> int(5) [2]=> int(7) }

```

## min

```php
<?php

var_dump(min(2, 3, 1, 6, 7));           // int(1)
var_dump(min([2, 4, 5]));               // int(2)
var_dump(min('hello', 0));              // string(5) "hello"
var_dump(min(0, 'hello'));              // int(0)
var_dump(min('42', -1));                // int(-1)
var_dump(min([2, 4, 8], [2, 5, 1]));    // array(3) { [0]=> int(2) [1]=> int(4) [2]=> int(8) }
var_dump(min([2, 2, 2], [2, 1, 1, 1])); // array(3) { [0]=> int(2) [1]=> int(2) [2]=> int(2) }
var_dump(min('hello', [2, 5, 7], 42));  // string(5) "hello"

```

## mt_getrandmax

```php
<?php

var_dump(mt_getrandmax());

```

## mt_rand

```php
<?php

var_dump(mt_rand());
var_dump(mt_rand(5, 15));

```

## mt_srand

```php
<?php

mt_srand((int) (microtime(true) * 10000));

```

## octdec

```php
<?php

var_dump(octdec('77'));  // int(63)
var_dump(octdec('100')); // int(64)
var_dump(octdec('777')); // int(511)

```

## pi

```php
<?php

var_dump(pi()); // float(3.1415926535898)

```

## pow

```php
<?php

var_dump(pow(0, 0));   // int(1)
var_dump(pow(-1, 20)); // int(1)
var_dump(pow(2, 8));   // int(256)

```

## rad2deg

```php
<?php

var_dump(rad2deg(0.5235987755983)); // float(30)
var_dump(rad2deg(1.5707963267949)); // float(90)
var_dump(rad2deg(3.1415926535898)); // float(180)

```

## rand

```php
<?php

var_dump(rand());
var_dump(rand(5, 15));

```

## round

```php
<?php

var_dump(round(3.4));                         // float(3)
var_dump(round(3.5));                         // float(4)
var_dump(round(3.6, 0));                      // float(4)
var_dump(round(1.95583, 2));                  // float(1.96)
var_dump(round(1241757, -3));                 // float(1242000)
var_dump(round(9.5, 0, PHP_ROUND_HALF_UP));   // float(10)
var_dump(round(9.5, 0, PHP_ROUND_HALF_DOWN)); // float(9)
var_dump(round(9.5, 0, PHP_ROUND_HALF_EVEN)); // float(10)
var_dump(round(9.5, 0, PHP_ROUND_HALF_ODD));  // float(9)

```

## sin

```php
<?php

var_dump(sin(-1)); // float(-0.8414709848079)
var_dump(sin(0));  // float(0)
var_dump(sin(1));  // float(0.8414709848079)

```

## sinh

```php
<?php

var_dump(sinh(-1)); // float(-1.1752011936438)
var_dump(sinh(0));  // float(0)
var_dump(sinh(1));  // float(1.1752011936438)

```

## sqrt

```php
<?php

var_dump(sqrt(8));  // float(2.8284271247462)
var_dump(sqrt(9));  // float(3)
var_dump(sqrt(10)); // float(3.1622776601684)

```

## srand

```php
<?php

srand((int) (microtime(true) * 10000));

```

## tan

```php
<?php

var_dump(tan(-1)); // float(-1.5574077246549)
var_dump(tan(0));  // float(0)
var_dump(tan(1));  // float(1.5574077246549)

```

## tanh

```php
<?php

var_dump(tanh(-1)); // float(-0.76159415595576)
var_dump(tanh(0));  // float(0)
var_dump(tanh(1));  // float(0.76159415595576)

```

