# 目录

* [chdir - 改变目录](#chdir)
* [closedir - 关闭目录句柄](#closedir)
* [dir - 返回一个 Directory 类实例](#dir)
* [getcwd - 取得当前工作目录](#getcwd)
* [opendir - 打开目录句柄](#opendir)
* [readdir - 从目录句柄中读取条目](#readdir)
* [rewinddir - 倒回目录句柄](#rewinddir)
* [scandir - 列出指定路径中的文件和目录](#scandir)

## chdir

```php
<?php

var_dump(chdir('./')); // bool(true)
var_dump(chdir('..')); // bool(true)
var_dump(chdir('/'));  // bool(true)

```

## closedir

```php
<?php

closedir();
closedir(opendir(__DIR__));

```

## dir

```php
<?php

var_dump(dir(__DIR__));

```

## getcwd

```php
<?php

var_dump(getcwd());

```

## opendir

```php
<?php

var_dump(opendir(__DIR__));

```

## readdir

```php
<?php

var_dump(readdir(opendir(__DIR__)));

```

## rewinddir

```php
<?php

rewinddir();
rewinddir(opendir(__DIR__));

```

## scandir

```php
<?php

var_dump(scandir(__DIR__));
var_dump(scandir(__DIR__, 1));

```

