# 字符串

* [addcslashes - 以 C 语言风格使用反斜线转义字符串](#addcslashes)
* [addslashes - 使用反斜线转义字符串](#addslashes)
* [bin2hex - 二进制字符串转换为十六进制值](#bin2hex)
* [chop - 删除字符串末端的空白字符（或者其他字符）](#chop)
* [chr - 返回指定的字符](#chr)
* [chunk_split - 将字符串分割成小块](#chunksplit)
* [convert_uudecode - 解码一个 uuencode 编码的字符串](#convertuudecode)
* [convert_uuencode - 使用 uuencode 编码一个字符串](#convertuuencode)
* [count_chars - 返回字符串所用字符的信息](#countchars)
* [crc32 - 计算一个字符串的 crc32 多项式](#crc32)
* [crypt - 单向字符串散列](#crypt)
* [echo - 输出一个或多个字符串](#echo)
* [explode - 使用一个字符串分割另一个字符串](#explode)
* [fprintf - 将格式化后的字符串写入到流](#fprintf)
* [get_html_translation_table - 返回使用 htmlspecialchars 和 htmlentities 后的转换表](#gethtmltranslationtable)
* [hebrev - 将逻辑顺序希伯来文转换为视觉顺序希伯来文](#hebrev)
* [hex2bin - 转换十六进制字符串为二进制字符串](#hex2bin)
* [html_entity_decode - 将 HTML 实体转换为相应的字符](#htmlentitydecode)
* [htmlentities - 将字符转换为相应的 HTML 实体](#htmlentities)
* [htmlspecialchars_decode - 将特殊的 HTML 实体转换回相应的特殊字符](#htmlspecialcharsdecode)
* [htmlspecialchars - 将特殊字符转换为相应的 HTML 实体](#htmlspecialchars)
* [implode - 将一个一维数组的值转化为字符串](#implode)
* [join - 将一个一维数组的值转化为字符串](#join)
* [lcfirst - 使一个字符串的第一个字符小写](#lcfirst)
* [levenshtein - 计算两个字符串之间的编辑距离](#levenshtein)
* [localeconv - 获取数字格式信息](#localeconv)
* [ltrim - 删除字符串开头的空白字符（或其他字符）](#ltrim)
* [md5_file - 计算指定文件的 MD5 散列值](#md5file)
* [md5 - 计算字符串的 MD5 散列值](#md5)
* [metaphone - 计算字符串的变音键](#metaphone)
* [nl_langinfo - 查询语言和区域信息](#nllanginfo)
* [nl2br - 在字符串所有新行之前插入 HTML 换行标记](#nl2br)
* [number_format - 以千位分隔符方式格式化一个数字](#numberformat)
* [ord - 转换字符串第一个字节为 0 - 255 之间的值](#ord)
* [parse_str - 将字符串解析成多个变量](#parsestr)
* [print - 输出字符串](#print)
* [printf - 输出格式化字符串](#printf)
* [quoted_printable_decode - 将 quoted-printable 字符串转换为 8-bit 字符串](#quotedprintabledecode)
* [quoted_printable_encode - 将 8-bit 字符串转换成 quoted-printable 字符串](#quotedprintableencode)
* [quotemeta - 转义元字符集](#quotemeta)
* [rtrim - 删除字符串末端的空白字符（或者其他字符）](#rtrim)
* [setlocale - 设置地区信息](#setlocale)
* [sha1_file - 计算文件的 sha1 散列值](#sha1file)
* [sha1 - 计算字符串的 sha1 散列值](#sha1)
* [similar_text - 计算两个字符串的相似度](#similartext)
* [soundex - 计算字符串的 soundex 键名](#soundex)
* [sprintf - 返回格式化的字符串](#sprintf)
* [sscanf - 根据指定格式解析输入的字符](#sscanf)
* [str_getcsv - 解析 CSV 字符串为一个数组](#strgetcsv)
* [str_ireplace - str_replace 的忽略大小写版本](#strireplace)
* [str_pad - 使用另一个字符串填充字符串为指定长度](#strpad)
* [str_repeat - 重复一个字符串](#strrepeat)
* [str_replace - 子字符串替换](#strreplace)
* [str_rot13 - 对字符串执行 ROT13 转换](#strrot13)
* [str_shuffle - 随机打乱一个字符串](#strshuffle)
* [str_split - 将字符串转换为数组](#strsplit)
* [str_word_count - 返回字符串中单词的使用情况](#strwordcount)
* [strcasecmp - 二进制安全比较字符串（不区分大小写）](#strcasecmp)
* [strchr - 查找字符串的首次出现](#strchr)
* [strcmp - 二进制安全字符串比较](#strcmp)
* [strcoll - 基于区域设置的字符串比较](#strcoll)
* [strcspn - 获取不匹配遮罩的起始子字符串的长度](#strcspn)
* [strip_tags - 从字符串中去除 HTML 和 PHP 标记](#striptags)
* [stripcslashes - 反引用一个使用 addcslashes 转义的字符串](#stripcslashes)
* [stripos - 查找字符串首次出现的位置（不区分大小写）](#stripos)
* [stripslashes - 反引用一个引用字符串](#stripslashes)
* [stristr - strstr 函数的忽略大小写版本](#stristr)
* [strlen - 获取字符串长度](#strlen)
* [strnatcasecmp - 使用自然顺序算法比较字符串（不区分大小写）](#strnatcasecmp)
* [strnatcmp - 使用自然排序算法比较字符串](#strnatcmp)
* [strncasecmp - 二进制安全比较字符串开头的若干个字符（不区分大小写）](#strncasecmp)
* [strncmp - 二进制安全比较字符串开头的若干个字符](#strncmp)
* [strpbrk - 在字符串中查找一组字符的任何一个字符](#strpbrk)
* [strpos - 查找字符串首次出现的位置](#strpos)
* [strrchr - 查找指定字符在字符串中的最后一次出现](#strrchr)
* [strrev - 反转字符串](#strrev)
* [strripos - 计算指定字符串在目标字符串中最后一次出现的位置（不区分大小写）](#strripos)
* [strrpos - 计算指定字符串在目标字符串中最后一次出现的位置](#strrpos)
* [strspn - 计算字符串中全部字符都存在于指定字符集合中的第一段子串的长度](#strspn)
* [strstr - 查找字符串的首次出现](#strstr)
* [strtok - 标记分割字符串](#strtok)
* [strtolower - 将字符串转化为小写](#strtolower)
* [strtoupper - 将字符串转化为大写](#strtoupper)
* [strtr - 转换指定字符](#strtr)
* [substr_compare - 二进制安全比较字符串（从偏移位置比较指定长度）](#substrcompare)
* [substr_count - 计算字串出现的次数](#substrcount)
* [substr_replace - 替换字符串的子串](#substrreplace)
* [substr - 返回字符串的子串](#substr)
* [trim - 去除字符串首尾处的空白字符（或者其他字符）](#trim)
* [ucfirst - 将字符串的首字母转换为大写](#ucfirst)
* [ucwords - 将字符串中每个单词的首字母转换为大写](#ucwords)
* [vfprintf - 将格式化字符串写入流](#vfprintf)
* [vprintf - 输出格式化字符串](#vprintf)
* [vsprintf - 返回格式化字符串](#vsprintf)
* [wordwrap - 打断字符串为指定数量的字串](#wordwrap)

## addcslashes

```php
<?php

var_dump(addcslashes("'", "'"));         // string(2) "\'"
var_dump(addcslashes('"', '"'));         // string(2) "\""
var_dump(addcslashes('\\', '\\'));       // string(2) "\\"
var_dump(addcslashes('AaBbCc', 'a'));    // string(7) "A\aBbCc"
var_dump(addcslashes('AaBbCc', 'A'));    // string(7) "\AaBbCc"
var_dump(addcslashes('AaBbCc', 'a..z')); // string(9) "A\aB\bC\c"
var_dump(addcslashes('AaBbCc', 'A..Z')); // string(9) "\Aa\Bb\Cc"
var_dump(addcslashes('AaBbCc', 'A..z')); // string(12) "\A\a\B\b\C\c"

```

## addslashes

```php
<?php

var_dump(addslashes('foo')); // string(3) "foo"
var_dump(addslashes("'"));   // string(2) "\'"
var_dump(addslashes('"'));   // string(2) "\""
var_dump(addslashes('\\'));  // string(2) "\\"

```

## bin2hex

```php
<?php

var_dump(bin2hex('0'));   // string(2) "30"
var_dump(bin2hex('1'));   // string(2) "31"
var_dump(bin2hex('a'));   // string(2) "61"
var_dump(bin2hex('A'));   // string(2) "41"
var_dump(bin2hex('foo')); // string(6) "666f6f"

```

## chop

```php
<?php

var_dump(chop('foo'));            // string(3) "foo"
var_dump(chop(' foo'));           // string(4) " foo"
var_dump(chop('foo '));           // string(3) "foo"
var_dump(chop("foo \r\n\t"));     // string(3) "foo"
var_dump(chop('foo', 'o'));       // string(1) "f"
var_dump(chop('AaBbCc', 'A..Z')); // string(6) "AaBbCc"
var_dump(chop('AaBbCc', 'A..z')); // string(0) ""

```

## chr

```php
<?php

var_dump(chr(61));   // string(1) "="
var_dump(chr(061));  // string(1) "1"
var_dump(chr(0x61)); // string(1) "a"

```

## chunk_split

```php
<?php

var_dump(chunk_split('AaBbCc'));
// string(8) "AaBbCc
// "
var_dump(chunk_split('AaBbCc', 2));
// string(12) "Aa
// Bb
// Cc
// "
var_dump(chunk_split('AaBbCc', 2, '.'));
// string(9) "Aa.Bb.Cc."

```

## convert_uudecode

```php
<?php

var_dump(convert_uudecode("#9F]O\n`\n")); // string(3) "foo"

```

## convert_uuencode

```php
<?php

var_dump(convert_uuencode('foo'));
// string(8) "#9F]O
// `
// "

```

## count_chars

```php
<?php

var_dump(count_chars('foo'));
var_dump(count_chars('foo', 0));
var_dump(count_chars('foo', 1));
var_dump(count_chars('foo', 2));
var_dump(count_chars('foo', 3));
var_dump(count_chars('foo', 4));

```

## crc32

```php
<?php

var_dump(crc32('foo')); // int(2356372769)

```

## crypt

```php
<?php

var_dump(crypt('password'));
var_dump(crypt('password', '$1$testsalt$'));

```

## echo

```php
<?php

$foo = 'foo';
$bar = 'bar';

echo $foo;       // foo
echo $bar;       // bar
echo $foo, $bar; // foobar

```

## explode

```php
<?php

var_dump(explode(' ', 'f o o'));     // array(3) { [0]=> string(1) "f" [1]=> string(1) "o" [2]=> string(1) "o" }
var_dump(explode(' ', 'f o o', 2));  // array(2) { [0]=> string(1) "f" [1]=> string(3) "o o" }
var_dump(explode(' ', 'f o o', -1)); // array(2) { [0]=> string(1) "f" [1]=> string(1) "o" }

```

## fprintf

```php
<?php

var_dump(fprintf(fopen(__DIR__ . '/example.txt', 'w'), '%s', 'foo'));                                       // int(3)
var_dump(fprintf(fopen(__DIR__ . '/example.txt', 'w'), '%04d-%02d-%02d', date('Y'), date('m'), date('d'))); // int(10)

```

## get_html_translation_table

```php
<?php

var_dump(get_html_translation_table());
var_dump(get_html_translation_table(HTML_ENTITIES, ENT_QUOTES | ENT_HTML5));

```

## hebrev

```php
<?php

var_dump(hebrev('foo')); // string(3) "foo"

```

## hex2bin

```php
<?php

var_dump(hex2bin('666f6f')); // string(3) "foo"
var_dump(hex2bin('626172')); // string(3) "bar"

```

## html_entity_decode

```php
<?php

var_dump(html_entity_decode("&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"));                       // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(html_entity_decode("&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;", ENT_COMPAT));           // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(html_entity_decode("&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;", ENT_QUOTES)); // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(html_entity_decode("&lt;p id=\"foo\" class='foo'&gt;foo&lt;/p&gt;", ENT_NOQUOTES));                 // string(31) "<p id="foo" class='foo'>foo</p>"

```

## htmlentities

```php
<?php

$string = <<<EOT
             <p id="foo" class='foo'>foo</p>
             EOT;
var_dump(htmlentities($string));                      // string(53) "&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlentities($string, ENT_COMPAT));          // string(53) "&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlentities($string, ENT_QUOTES));          // string(63) "&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;"
var_dump(htmlentities($string, ENT_NOQUOTES));        // string(43) "&lt;p id="foo" class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlentities($string, ENT_QUOTES, 'UTF-8')); // string(63) "&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;"

```

## htmlspecialchars_decode

```php
<?php

var_dump(htmlspecialchars_decode("&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"));                       // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(htmlspecialchars_decode("&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;", ENT_COMPAT));           // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(htmlspecialchars_decode("&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;", ENT_QUOTES)); // string(31) "<p id="foo" class='foo'>foo</p>"
var_dump(htmlspecialchars_decode("&lt;p id=\"foo\" class='foo'&gt;foo&lt;/p&gt;", ENT_NOQUOTES));                 // string(31) "<p id="foo" class='foo'>foo</p>"

```

## htmlspecialchars

```php
<?php

$string = <<<EOT
             <p id="foo" class='foo'>foo</p>
             EOT;
var_dump(htmlspecialchars($string));                      // string(53) "&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlspecialchars($string, ENT_COMPAT));          // string(53) "&lt;p id=&quot;foo&quot; class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlspecialchars($string, ENT_QUOTES));          // string(63) "&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;"
var_dump(htmlspecialchars($string, ENT_NOQUOTES));        // string(43) "&lt;p id="foo" class='foo'&gt;foo&lt;/p&gt;"
var_dump(htmlspecialchars($string, ENT_QUOTES, 'UTF-8')); // string(63) "&lt;p id=&quot;foo&quot; class=&#039;foo&#039;&gt;foo&lt;/p&gt;"

```

## implode

```php
<?php

var_dump(implode(['foo', 'bar', 'baz']));       // string(9) "foobarbaz"
var_dump(implode('', ['foo', 'bar', 'baz']));   // string(9) "foobarbaz"
var_dump(implode(', ', ['foo', 'bar', 'baz'])); // string(13) "foo, bar, baz"

```

## join

```php
<?php

var_dump(join(['foo', 'bar', 'baz']));       // string(9) "foobarbaz"
var_dump(join('', ['foo', 'bar', 'baz']));   // string(9) "foobarbaz"
var_dump(join(', ', ['foo', 'bar', 'baz'])); // string(13) "foo, bar, baz"

```

## lcfirst

```php
<?php

var_dump(lcfirst('foo')); // string(3) "foo"
var_dump(lcfirst('FOO')); // string(3) "fOO"

```

## levenshtein

```php
<?php

var_dump(levenshtein('foo', 'foo')); // int(0)
var_dump(levenshtein('foo', 'f'));   // int(2)
var_dump(levenshtein('foo', 'fu'));  // int(2)
var_dump(levenshtein('foo', 'bar')); // int(3)
var_dump(levenshtein('foo', 'oof')); // int(2)

```

## localeconv

```php
<?php

var_dump(localeconv());

```

## ltrim

```php
<?php

var_dump(ltrim('foo'));            // string(3) "foo"
var_dump(ltrim('foo '));           // string(4) "foo "
var_dump(ltrim(' foo'));           // string(3) "foo"
var_dump(ltrim(" \r\n\tfoo"));     // string(3) "foo"
var_dump(ltrim('foo', 'f'));       // string(2) "oo"
var_dump(ltrim('AaBbCc', 'A..Z')); // string(5) "aBbCc"
var_dump(ltrim('AaBbCc', 'A..z')); // string(0) ""

```

## md5_file

```php
<?php

var_dump(md5_file(__DIR__ . '/example.txt'));
var_dump(md5_file(__DIR__ . '/example.txt', true));

```

## md5

```php
<?php

var_dump(md5('foo'));
var_dump(md5('bar', true));

```

## metaphone

```php
<?php

var_dump(metaphone('programming'));    // string(7) "PRKRMNK"
var_dump(metaphone('programmer'));     // string(6) "PRKRMR"
var_dump(metaphone('programming', 5)); // string(5) "PRKRM"
var_dump(metaphone('programmer', 5));  // string(5) "PRKRM"

```

## nl_langinfo

```php
<?php

var_dump(nl_langinfo(DAY_1));

```

## nl2br

```php
<?php

var_dump(nl2br("foo\nbar"));
// string(13) "foo<br />
// bar"
var_dump(nl2br("foo\nbar", false));
// string(11) "foo<br>
// bar"

```

## number_format

```php
<?php

var_dump(number_format(1234.5678));              // string(5) "1,235"
var_dump(number_format(1234.5678, 0));           // string(5) "1,235"
var_dump(number_format(1234.5678, 2));           // string(8) "1,234.57"
var_dump(number_format(1234.5678, 2, ',', ' ')); // string(8) "1 234,57"
var_dump(number_format(1234.5678, 2, '.', ''));  // string(7) "1234.57"

```

## ord

```php
<?php

var_dump(ord("\r")); // int(13)
var_dump(ord("\n")); // int(10)
var_dump(ord("\t")); // int(9)
var_dump(ord('f'));  // int(102)

```

## parse_str

```php
<?php

parse_str('foo=foo&bar=bar&baz[]=baz', $output);
var_dump($output); // array(3) { ["foo"]=> string(3) "foo" ["bar"]=> string(3) "bar" ["baz"]=> array(1) { [0]=> string(3) "baz" } }

parse_str('f oo=foo', $output);
var_dump($output); // array(1) { ["f_oo"]=> string(3) "foo" }

```

## print

```php
<?php

print 'Hello World!';      // Hello World!

$foo = 'foo';
print $foo;                // foo

$bar = 'bar';
print "\$bar is $bar";     // $bar is bar

$baz = ['baz'];
print "this is {$baz[0]}"; // this is baz

print <<<EOT
         qux
         EOT;              // qux

```

## printf

```php
<?php

printf('%d', 233);             // 233
printf('%.1f', 22.12);         // 22.1
printf('%s', 'foo');           // foo
printf('%s %s', 'foo', 'bar'); // foo bar

```

## quoted_printable_decode

```php
<?php

var_dump(quoted_printable_decode('foo')); // string(3) "foo"

```

## quoted_printable_encode

```php
<?php

var_dump(quoted_printable_encode('foo')); // string(3) "foo"

```

## quotemeta

```php
<?php

var_dump(quotemeta('.'));  // string(2) "\."
var_dump(quotemeta("'"));  // string(1) "'"
var_dump(quotemeta('"'));  // string(1) """
var_dump(quotemeta('\\')); // string(2) "\\"
var_dump(quotemeta('+'));  // string(2) "\+"
var_dump(quotemeta('*'));  // string(2) "\*"
var_dump(quotemeta('?'));  // string(2) "\?"
var_dump(quotemeta('['));  // string(2) "\["
var_dump(quotemeta('^'));  // string(2) "\^"
var_dump(quotemeta(']'));  // string(2) "\]"
var_dump(quotemeta('('));  // string(2) "\("
var_dump(quotemeta('$'));  // string(2) "\$"
var_dump(quotemeta(')'));  // string(2) "\)"

```

## rtrim

```php
<?php

var_dump(rtrim('foo'));            // string(3) "foo"
var_dump(rtrim(' foo'));           // string(4) " foo"
var_dump(rtrim('foo '));           // string(3) "foo"
var_dump(rtrim("foo \r\n\t"));     // string(3) "foo"
var_dump(rtrim('foo', 'o'));       // string(1) "f"
var_dump(rtrim('AaBbCc', 'A..Z')); // string(6) "AaBbCc"
var_dump(rtrim('AaBbCc', 'A..z')); // string(0) ""

```

## setlocale

```php
<?php

var_dump(setlocale(LC_ALL, 'nld_nld'));

```

## sha1_file

```php
<?php

var_dump(sha1_file(__DIR__ . '/example.txt'));
var_dump(sha1_file(__DIR__ . '/example.txt', true));

```

## sha1

```php
<?php

var_dump(sha1('foo'));
var_dump(sha1('foo', true));

```

## similar_text

```php
<?php

var_dump(similar_text('foo', 'bar'));            // int(0)
var_dump(similar_text('foo', 'fu'));             // int(1)
var_dump(similar_text('foo', 'full'));           // int(1)
var_dump(similar_text('foo', 'full', $percent)); // int(1)

```

## soundex

```php
<?php

var_dump(soundex('foo'));  // string(4) "F000"
var_dump(soundex('fu'));   // string(4) "F000"
var_dump(soundex('full')); // string(4) "F400"

```

## sprintf

```php
<?php

var_dump(sprintf('%d', 233));             // string(3) "233"
var_dump(sprintf('%.1f', 22.12));         // string(4) "22.1"
var_dump(sprintf('%s', 'foo'));           // string(3) "foo"
var_dump(sprintf('%s %s', 'foo', 'bar')); // string(7) "foo bar"

```

## sscanf

```php
<?php

var_dump(sscanf('233', '%d'));                        // array(1) { [0]=> int(233) }
var_dump(sscanf('foo=foo bar=bar', 'foo=%s bar=%s')); // array(2) { [0]=> string(3) "foo" [1]=> string(3) "bar" }

```

## str_getcsv

```php
<?php

var_dump(str_getcsv('foo,bar'));      // array(2) { [0]=> string(3) "foo" [1]=> string(3) "bar" }
var_dump(str_getcsv('foo;bar', ';')); // array(2) { [0]=> string(3) "foo" [1]=> string(3) "bar" }

```

## str_ireplace

```php
<?php

var_dump(str_ireplace('FOO', '', 'foo bar'));                              // string(4) " bar"
var_dump(str_ireplace('foo', '', 'foo bar'));                              // string(4) " bar"
var_dump(str_ireplace('foo', 'bar', 'foo bar'));                           // string(7) "bar bar"
var_dump(str_ireplace(['foo', 'bar'], '', 'foo bar'));                     // string(1) " "
var_dump(str_ireplace(['foo', 'bar'], 'baz', 'foo bar'));                  // string(7) "baz baz"
var_dump(str_ireplace(['foo', 'bar'], ['baz', 'qux'], 'foo bar'));         // string(7) "baz qux"
var_dump(str_ireplace(['foo', 'bar'], ['baz', 'qux'], 'foo bar', $count)); // string(7) "baz qux"
var_dump(str_ireplace(['f', 'o'], ['fo', '0'], 'foo'));                    // string(4) "f000"

```

## str_pad

```php
<?php

var_dump(str_pad('foo', 1));                      // string(3) "foo"
var_dump(str_pad('foo', 10));                     // string(10) "foo       "
var_dump(str_pad('foo', 10, '='));                // string(10) "foo======="
var_dump(str_pad('foo', 10, '=', STR_PAD_RIGHT)); // string(10) "foo======="
var_dump(str_pad('foo', 10, '=', STR_PAD_LEFT));  // string(10) "=======foo"
var_dump(str_pad('foo', 10, '=', STR_PAD_BOTH));  // string(10) "===foo===="
var_dump(str_pad('foo', 10, '-='));               // string(10) "foo-=-=-=-"
var_dump(str_pad('foo', 10, '-=', STR_PAD_BOTH)); // string(10) "-=-foo-=-="

```

## str_repeat

```php
<?php

var_dump(str_repeat('foo', 0)); // string(0) ""
var_dump(str_repeat('foo', 5)); // string(15) "foofoofoofoofoo"

```

## str_replace

```php
<?php

var_dump(str_replace('FOO', '', 'foo bar'));                              // string(7) "foo bar"
var_dump(str_replace('foo', '', 'foo bar'));                              // string(4) " bar"
var_dump(str_replace('foo', 'bar', 'foo bar'));                           // string(7) "bar bar"
var_dump(str_replace(['foo', 'bar'], '', 'foo bar'));                     // string(1) " "
var_dump(str_replace(['foo', 'bar'], 'baz', 'foo bar'));                  // string(7) "baz baz"
var_dump(str_replace(['foo', 'bar'], ['baz', 'qux'], 'foo bar'));         // string(7) "baz qux"
var_dump(str_replace(['foo', 'bar'], ['baz', 'qux'], 'foo bar', $count)); // string(7) "baz qux"
var_dump(str_replace(['f', 'o'], ['fo', '0'], 'foo'));                    // string(4) "f000"

```

## str_rot13

```php
<?php

var_dump(str_rot13('PHP')); // string(3) "CUC"

```

## str_shuffle

```php
<?php

var_dump(str_shuffle('foo'));

```

## str_split

```php
<?php

var_dump(str_split('foo'));    // array(3) { [0]=> string(1) "f" [1]=> string(1) "o" [2]=> string(1) "o" }
var_dump(str_split('foo', 2)); // array(2) { [0]=> string(2) "fo" [1]=> string(1) "o" }
var_dump(str_split('foo', 5)); // array(1) { [0]=> string(3) "foo" }

```

## str_word_count

```php
<?php

var_dump(str_word_count('foo fo0'));         // int(2)
var_dump(str_word_count('foo fo0', 1));      // array(2) { [0]=> string(3) "foo" [1]=> string(2) "fo" }
var_dump(str_word_count('foo fo0', 2));      // array(2) { [0]=> string(3) "foo" [4]=> string(2) "fo" }
var_dump(str_word_count('foo fo0', 2, '0')); // array(2) { [0]=> string(3) "foo" [4]=> string(3) "fo0" }

```

## strcasecmp

```php
<?php

var_dump(strcasecmp('FOO', 'foo')); // int(0)
var_dump(strcasecmp('foo', 'foo')); // int(0)
var_dump(strcasecmp('foo', 'bar')); // int(4)
var_dump(strcasecmp('bar', 'foo')); // int(-4)

```

## strchr

```php
<?php

var_dump(strchr('foo bar baz qux', 'ba'));        // string(11) "bar baz qux"
var_dump(strchr('foo bar baz qux', 'bar'));       // string(11) "bar baz qux"
var_dump(strchr('foo bar baz qux', 'baz'));       // string(7) "baz qux"
var_dump(strchr('foo bar baz qux', 'baz', true)); // string(8) "foo bar "

```

## strcmp

```php
<?php

var_dump(strcmp('FOO', 'foo')); // int(-1)
var_dump(strcmp('foo', 'foo')); // int(0)
var_dump(strcmp('foo', 'bar')); // int(1)
var_dump(strcmp('bar', 'foo')); // int(-1)

```

## strcoll

```php
<?php

var_dump(strcoll('FOO', 'foo')); // int(-1)
var_dump(strcoll('foo', 'foo')); // int(0)
var_dump(strcoll('foo', 'bar')); // int(1)
var_dump(strcoll('bar', 'foo')); // int(-1)

```

## strcspn

```php
<?php

var_dump(strcspn('foo bar baz qux', 'abcde'));         // int(4)
var_dump(strcspn('foo bar baz qux', 'abcde', 4));      // int(0)
var_dump(strcspn('foo bar baz qux', 'abcde', -5));     // int(5)
var_dump(strcspn('foo bar baz qux', 'abcde', 2, 2));   // int(2)
var_dump(strcspn('foo bar baz qux', 'abcde', -5, -1)); // int(4)

```

## strip_tags

```php
<?php

var_dump(strip_tags('foo'));                            // string(3) "foo"
var_dump(strip_tags('<p>foo</p><a>bar</a>'));           // string(6) "foobar"
var_dump(strip_tags('<p>foo</p><a>bar</a>', '<p>'));    // string(13) "<p>foo</p>bar"
var_dump(strip_tags('<p>foo</p><a>bar</a>', '<a>'));    // string(13) "foo<a>bar</a>"
var_dump(strip_tags('<p>foo</p><a>bar</a>', '<p><a>')); // string(20) "<p>foo</p><a>bar</a>"

```

## stripcslashes

```php
<?php

var_dump(stripcslashes('\'')); // string(1) "'"
var_dump(stripcslashes('\"')); // string(1) """
var_dump(stripcslashes('\\')); // string(1) "\"

```

## stripos

```php
<?php

var_dump(stripos('foo', 'a'));     // bool(false)
var_dump(stripos('foo', 'o'));     // int(1)
var_dump(stripos('foo', 'O'));     // int(1)
var_dump(stripos('foo', 'o', 1));  // int(1)
var_dump(stripos('foo', 'o', 2));  // int(2)
var_dump(stripos('foo', 'o', -1)); // int(2)
var_dump(stripos('foo', 'oo'));    // int(1)
var_dump(stripos('foo', 'oa'));    // bool(false)

```

## stripslashes

```php
<?php

var_dump(stripslashes('foo')); // string(3) "foo"
var_dump(stripslashes('\''));  // string(1) "'"
var_dump(stripslashes('\"'));  // string(1) """
var_dump(stripslashes('\\'));  // string(0) ""

```

## stristr

```php
<?php

var_dump(stristr('foo Bar baz qux', 'b'));         // string(11) "Bar baz qux"
var_dump(stristr('foo Bar baz qux', 'bar'));       // string(11) "Bar baz qux"
var_dump(stristr('foo Bar baz qux', 'baz'));       // string(7) "baz qux"
var_dump(stristr('foo Bar baz qux', 'baz', true)); // string(8) "foo Bar "

```

## strlen

```php
<?php

var_dump(strlen(''));        // int(0)
var_dump(strlen('foo'));     // int(3)
var_dump(strlen(' f o o ')); // int(7)

```

## strnatcasecmp

```php
<?php

var_dump(strnatcasecmp('foo12', 'foo1'));  // int(1)
var_dump(strnatcasecmp('foo12', 'foo10')); // int(1)
var_dump(strnatcasecmp('foo12', 'foo2'));  // int(1)
var_dump(strnatcasecmp('Foo12', 'foo2'));  // int(1)

```

## strnatcmp

```php
<?php

var_dump(strnatcmp('foo12', 'foo1'));  // int(1)
var_dump(strnatcmp('foo12', 'foo10')); // int(1)
var_dump(strnatcmp('foo12', 'foo2'));  // int(1)
var_dump(strnatcmp('Foo12', 'foo2'));  // int(-1)

```

## strncasecmp

```php
<?php

var_dump(strncasecmp('bar', 'BAZ', 1)); // int(0)
var_dump(strncasecmp('bar', 'BAZ', 2)); // int(0)
var_dump(strncasecmp('bar', 'BAZ', 3)); // int(-8)

```

## strncmp

```php
<?php

var_dump(strncmp('bar', 'baz', 1)); // int(0)
var_dump(strncmp('bar', 'baz', 2)); // int(0)
var_dump(strncmp('bar', 'baz', 3)); // int(-1)

```

## strpbrk

```php
<?php

var_dump(strpbrk('foo bar baz qux', 'abcde')); // string(11) "bar baz qux"
var_dump(strpbrk('foo bar baz qux', 'aBcde')); // string(10) "ar baz qux"

```

## strpos

```php
<?php

var_dump(strpos('foo', 'a'));     // bool(false)
var_dump(strpos('foo', 'o'));     // int(1)
var_dump(strpos('foo', 'O'));     // bool(false)
var_dump(strpos('foo', 'o', 1));  // int(1)
var_dump(strpos('foo', 'o', 2));  // int(2)
var_dump(strpos('foo', 'o', -1)); // int(2)
var_dump(strpos('foo', 'oo'));    // int(1)
var_dump(strpos('foo', 'oa'));    // bool(false)

```

## strrchr

```php
<?php

var_dump(strrchr('foo bar baz qux', 'a'));  // string(6) "az qux"
var_dump(strrchr('foo bar baz qux', 'aa')); // string(6) "az qux"

```

## strrev

```php
<?php

var_dump(strrev('foo')); // string(3) "oof"
var_dump(strrev('bar')); // string(3) "rab"

```

## strripos

```php
<?php

var_dump(strripos('foo', 'a'));     // bool(false)
var_dump(strripos('foo', 'O'));     // int(2)
var_dump(strripos('foo', 'o'));     // int(2)
var_dump(strripos('foo', 'f'));     // int(0)
var_dump(strripos('foo', 'oo'));    // int(1)
var_dump(strripos('foo', 'o', -1)); // int(2)
var_dump(strripos('foo', 'o', -2)); // int(1)

```

## strrpos

```php
<?php

var_dump(strrpos('foo', 'a'));     // bool(false)
var_dump(strrpos('foo', 'O'));     // bool(false)
var_dump(strrpos('foo', 'o'));     // int(2)
var_dump(strrpos('foo', 'f'));     // int(0)
var_dump(strrpos('foo', 'oo'));    // int(1)
var_dump(strrpos('foo', 'o', -1)); // int(2)
var_dump(strrpos('foo', 'o', -2)); // int(1)

```

## strspn

```php
<?php

var_dump(strspn('foo bar baz qux', 'abfo'));            // int(3)
var_dump(strspn('foo bar baz qux', 'abfo '));           // int(6)
var_dump(strspn('foo bar baz qux', 'abfo ', 2));        // int(4)
var_dump(strspn('foo bar baz qux', 'abfo ', -12));      // int(3)
var_dump(strspn('foo bar baz qux', 'abfo ', 2, 5));     // int(4)
var_dump(strspn('foo bar baz qux', 'abfo ', -12, 5));   // int(3)
var_dump(strspn('foo bar baz qux', 'abfo ', -12, -10)); // int(2)

```

## strstr

```php
<?php

var_dump(strstr('foo Bar baz qux', 'b'));         // string(7) "baz qux"
var_dump(strstr('foo Bar baz qux', 'bar'));       // bool(false)
var_dump(strstr('foo Bar baz qux', 'baz'));       // string(7) "baz qux"
var_dump(strstr('foo Bar baz qux', 'baz', true)); // string(8) "foo Bar "

```

## strtok

```php
<?php

var_dump(strtok("\r\n\t"));                       // bool(false)
var_dump(strtok("foo\rbar\nbaz\tqux", "\r\n\t")); // string(3) "foo"
var_dump(strtok("\r\n\t"));                       // string(3) "bar"
var_dump(strtok("\r\n\t"));                       // string(3) "baz"
var_dump(strtok("\r\n\t"));                       // string(3) "qux"
var_dump(strtok("\r\n\t"));                       // bool(false)

```

## strtolower

```php
<?php

var_dump(strtolower('foo')); // string(3) "foo"
var_dump(strtolower('FOO')); // string(3) "foo"

```

## strtoupper

```php
<?php

var_dump(strtoupper('foo')); // string(3) "FOO"
var_dump(strtoupper('FOO')); // string(3) "FOO"

```

## strtr

```php
<?php

var_dump(strtr('foo', 'f', 'F'));       // string(3) "Foo"
var_dump(strtr('foo', 'o', 'O'));       // string(3) "fOO"
var_dump(strtr('foo', 'fo', '10'));     // string(3) "100"
var_dump(strtr('foo', ['fo' => '10'])); // string(3) "10o"

```

## substr_compare

```php
<?php

var_dump(substr_compare('abcde', 'bc', 1, 2));       // int(0)
var_dump(substr_compare('abcde', 'de', -2, 2));      // int(0)
var_dump(substr_compare('abcde', 'bc', 1, 2));       // int(0)
var_dump(substr_compare('abcde', 'BC', 1, 2, true)); // int(0)
var_dump(substr_compare('abcde', 'bc', 1, 3));       // int(1)
var_dump(substr_compare('abcde', 'cd', 1, 2));       // int(-1)

```

## substr_count

```php
<?php

var_dump(substr_count('foo bar baz qux', 'ba'));       // int(2)
var_dump(substr_count('foo bar baz qux', 'ba', 5));    // int(1)
var_dump(substr_count('foo bar baz qux', 'ba', 5, 3)); // int(0)

```

## substr_replace

```php
<?php

var_dump(substr_replace('foo bar baz', 'qux', 0));      // string(3) "qux"
var_dump(substr_replace('foo bar baz', 'qux', 8));      // string(11) "foo bar qux"
var_dump(substr_replace('foo bar baz', 'qux', -3));     // string(11) "foo bar qux"
var_dump(substr_replace('foo bar baz', 'qux', 0, 0));   // string(14) "quxfoo bar baz"
var_dump(substr_replace('foo bar baz', 'qux', 0, 1));   // string(13) "quxoo bar baz"
var_dump(substr_replace('foo bar baz', 'qux', 0, 3));   // string(11) "qux bar baz"
var_dump(substr_replace('foo bar baz', 'qux', -3, 0));  // string(14) "foo bar quxbaz"
var_dump(substr_replace('foo bar baz', 'qux', -3, 3));  // string(11) "foo bar qux"
var_dump(substr_replace('foo bar baz', 'qux', -3, -1)); // string(12) "foo bar quxz"

```

## substr

```php
<?php

var_dump(substr('foo', 0));      // string(3) "foo"
var_dump(substr('foo', 1));      // string(2) "oo"
var_dump(substr('foo', 1, 1));   // string(1) "o"
var_dump(substr('foo', 0, -2));  // string(1) "f"
var_dump(substr('foo', -2));     // string(2) "oo"
var_dump(substr('foo', -2, 1));  // string(1) "o"
var_dump(substr('foo', -3, -2)); // string(1) "f"

```

## trim

```php
<?php

var_dump(trim('foo'));               // string(3) "foo"
var_dump(trim(' foo'));              // string(3) "foo"
var_dump(trim('foo '));              // string(3) "foo"
var_dump(trim(" \r\n\tfoo \r\n\t")); // string(3) "foo"
var_dump(trim('foo', 'o'));          // string(1) "f"
var_dump(trim('AaBbCc', 'A..Z'));    // string(5) "aBbCc"
var_dump(trim('AaBbCc', 'A..z'));    // string(0) ""

```

## ucfirst

```php
<?php

var_dump(ucfirst('foo'));     // string(3) "Foo"
var_dump(ucfirst('foo bar')); // string(7) "Foo bar"

```

## ucwords

```php
<?php

var_dump(ucwords('foo'));          // string(3) "Foo"
var_dump(ucwords('foo bar'));      // string(7) "Foo Bar"
var_dump(ucwords('foo|bar'));      // string(7) "Foo|bar"
var_dump(ucwords('foo|bar', '|')); // string(7) "Foo|Bar"

```

## vfprintf

```php
<?php

var_dump(vfprintf(fopen(__DIR__ . '/example.txt', 'w'), '%s', ['foo']));                                       // int(3)
var_dump(vfprintf(fopen(__DIR__ . '/example.txt', 'w'), '%04d-%02d-%02d', [date('Y'), date('m'), date('d')])); // int(10)

```

## vprintf

```php
<?php

vprintf('%d', [233]);             // 233
vprintf('%.1f', [22.12]);         // 22.1
vprintf('%s', ['foo']);           // foo
vprintf('%s %s', ['foo', 'bar']); // foo bar

```

## vsprintf

```php
<?php

var_dump(vsprintf('%d', [233]));             // string(3) "233"
var_dump(vsprintf('%.1f', [22.12]));         // string(4) "22.1"
var_dump(vsprintf('%s', ['foo']));           // string(3) "foo"
var_dump(vsprintf('%s %s', ['foo', 'bar'])); // string(7) "foo bar"

```

## wordwrap

```php
<?php

var_dump(wordwrap('A very long woooooooooooord.'));
// string(28) "A very long woooooooooooord."
var_dump(wordwrap('A very long woooooooooooord.', 8));
// string(28) "A very
// long
// woooooooooooord."
var_dump(wordwrap('A very long woooooooooooord.', 8, "|\n"));
// string(30) "A very|
// long|
// woooooooooooord."
var_dump(wordwrap('A very long woooooooooooord.', 8, "\n", true));
// string(29) "A very
// long
// wooooooo
// ooooord."

```

