# 语言参考

* [基本语法](/docs/语言参考/基本语法.html)
  * [PHP 标记](/docs/语言参考/基本语法/PHP 标记.html)
  * [从 HTML 中分离](/docs/语言参考/基本语法/从 HTML 中分离.html)
  * [指令分隔符](/docs/语言参考/基本语法/指令分隔符.html)
  * [注释](/docs/语言参考/基本语法/注释.html)
* [类型](/docs/语言参考/类型.html)
  * [Boolean 布尔类型](/docs/语言参考/类型/Boolean 布尔类型.html)
  * [Integer 整型](/docs/语言参考/类型/Integer 整型.html)
  * [Float 浮点型](/docs/语言参考/类型/Float 浮点型.html)
  * [String 字符串](/docs/语言参考/类型/String 字符串.html)
  * [Array 数组](/docs/语言参考/类型/Array 数组.html)
  * [Object 对象](/docs/语言参考/类型/Object 对象.html)
  * [Resource 资源类型](/docs/语言参考/类型/Resource 资源类型.html)
  * [NULL](/docs/语言参考/类型/NULL.html)
  * [Callable 可调用类型](/docs/语言参考/类型/Callable 可调用类型.html)
  * [类型转换的判别](/docs/语言参考/类型/类型转换的判别.html)
* [变量](/docs/语言参考/变量.html)
  * [基本语法](/docs/语言参考/变量/基本语法.html)
  * [变量范围](/docs/语言参考/变量/变量范围.html)
  * [可变变量](/docs/语言参考/变量/可变变量.html)
  * [来自 PHP 之外的变量](/docs/语言参考/变量/来自 PHP 之外的变量.html)
* [常量](/docs/语言参考/常量.html)
  * [基本语法](/docs/语言参考/常量/基本语法.html)
  * [魔术常量](/docs/语言参考/常量/魔术常量.html)
* [表达式](/docs/语言参考/表达式.html)
* [运算符](/docs/语言参考/运算符.html)
  * [运算符优先级](/docs/语言参考/运算符/运算符优先级.html)
  * [算数运算符](/docs/语言参考/运算符/算数运算符.html)
  * [赋值运算符](/docs/语言参考/运算符/赋值运算符.html)
  * [位运算符](/docs/语言参考/运算符/位运算符.html)
  * [比较运算符](/docs/语言参考/运算符/比较运算符.html)
  * [错误控制运算符](/docs/语言参考/运算符/错误控制运算符.html)
  * [执行运算符](/docs/语言参考/运算符/执行运算符.html)
  * [递增递减运算符](/docs/语言参考/运算符/递增递减运算符.html)
  * [逻辑运算符](/docs/语言参考/运算符/逻辑运算符.html)
  * [字符串运算符](/docs/语言参考/运算符/字符串运算符.html)
  * [数组运算符](/docs/语言参考/运算符/数组运算符.html)
  * [类型运算符](/docs/语言参考/运算符/类型运算符.html)
* [函数](/docs/语言参考/函数.html)
  * [用户自定义函数](/docs/语言参考/函数/用户自定义函数.html)
  * [函数的参数](/docs/语言参考/函数/函数的参数.html)
  * [返回值](/docs/语言参考/函数/返回值.html)
  * [可变函数](/docs/语言参考/函数/可变函数.html)
  * [匿名函数](/docs/语言参考/函数/匿名函数.html)
* [类与对象](/docs/语言参考/类与对象.html)
  * [基本语法](/docs/语言参考/类与对象/基本语法.html)
  * [属性](/docs/语言参考/类与对象/属性.html)
  * [类常量](/docs/语言参考/类与对象/类常量.html)
  * [类的自动加载](/docs/语言参考/类与对象/类的自动加载.html)
  * [构造函数和析构函数](/docs/语言参考/类与对象/构造函数和析构函数.html)
  * [访问控制](/docs/语言参考/类与对象/访问控制.html)
  * [对象继承](/docs/语言参考/类与对象/对象继承.html)
  * [范围解析操作符](/docs/语言参考/类与对象/范围解析操作符.html)
  * [Static 关键字](/docs/语言参考/类与对象/Static 关键字.html)
  * [抽象类](/docs/语言参考/类与对象/抽象类.html)
  * [对象接口](/docs/语言参考/类与对象/对象接口.html)
  * [Trait](/docs/语言参考/类与对象/Trait.html)
  * [匿名类](/docs/语言参考/类与对象/匿名类.html)
  * [重载](/docs/语言参考/类与对象/重载.html)
  * [遍历对象](/docs/语言参考/类与对象/遍历对象.html)
  * [魔术方法](/docs/语言参考/类与对象/魔术方法.html)
  * [Final 关键字](/docs/语言参考/类与对象/Final 关键字.html)
  * [对象复制](/docs/语言参考/类与对象/对象复制.html)
  * [对象比较](/docs/语言参考/类与对象/对象比较.html)
  * [类型约束](/docs/语言参考/类与对象/类型约束.html)
  * [后期静态绑定](/docs/语言参考/类与对象/后期静态绑定.html)
  * [对象和引用](/docs/语言参考/类与对象/对象和引用.html)
  * [对象序列化](/docs/语言参考/类与对象/对象序列化.html)
* [命名空间](/docs/语言参考/命名空间.html)
  * [基本语法](/docs/语言参考/命名空间/基本语法.html)
  * [定义子命名空间](/docs/语言参考/命名空间/定义子命名空间.html)
  * [在同一个文件中定义多个命名空间](/docs/语言参考/命名空间/在同一个文件中定义多个命名空间.html)
  * [使用命名空间 - 基础](/docs/语言参考/命名空间/使用命名空间 - 基础.html)
  * [命名空间和动态语言特征](/docs/语言参考/命名空间/命名空间和动态语言特征.html)
  * [namespace 关键字和 \_\_NAMESPACE\_\_ 魔术常量](/docs/语言参考/命名空间/namespace 关键字和 __NAMESPACE__ 魔术常量.html)
  * [使用命名空间 - 别名和导入](/docs/语言参考/命名空间/使用命名空间 - 别名和导入.html)
  * [全局空间](/docs/语言参考/命名空间/全局空间.html)
  * [使用命名空间 - 后备全局函数和常量](/docs/语言参考/命名空间/使用命名空间 - 后备全局函数和常量.html)
  * [名称解析规则](/docs/语言参考/命名空间/名称解析规则.html)
* [Errors](/docs/语言参考/Errors.html)
* [异常处理](/docs/语言参考/异常处理.html)
  * [基本语法](/docs/语言参考/异常处理/基本语法.html)
  * [扩展 PHP 内置的异常处理类](/docs/语言参考/异常处理/扩展 PHP 内置的异常处理类.html)
* [生成器](/docs/语言参考/生成器.html)
  * [生成器总览](/docs/语言参考/生成器/生成器总览.html)
  * [生成器语法](/docs/语言参考/生成器/生成器语法.html)
  * [生成器与 Iterator 对象比较](/docs/语言参考/生成器/生成器与 Iterator 对象比较.html)
* [引用的解释](/docs/语言参考/引用的解释.html)
  * [引用是什么](/docs/语言参考/引用的解释/引用是什么.html)
  * [引用不是什么](/docs/语言参考/引用的解释/引用不是什么.html)
  * [引用做什么](/docs/语言参考/引用的解释/引用做什么.html)
  * [引用传递](/docs/语言参考/引用的解释/引用传递.html)
  * [引用返回](/docs/语言参考/引用的解释/引用返回.html)
  * [取消引用](/docs/语言参考/引用的解释/取消引用.html)
  * [引用定位](/docs/语言参考/引用的解释/引用定位.html)
* [预定义变量](/docs/语言参考/预定义变量.html)
  * [超全局变量](/docs/语言参考/预定义变量/超全局变量.html)
  * [$GLOBALS](/docs/语言参考/预定义变量/$GLOBALS.html)
  * [$_GET](/docs/语言参考/预定义变量/$_GET.html)
  * [$_POST](/docs/语言参考/预定义变量/$_POST.html)
  * [$_COOKIE](/docs/语言参考/预定义变量/$_COOKIE.html)
  * [$_REQUEST](/docs/语言参考/预定义变量/$_REQUEST.html)
  * [$_FILES](/docs/语言参考/预定义变量/$_FILES.html)
  * [$_SESSION](/docs/语言参考/预定义变量/$_SESSION.html)
  * [$_SERVER](/docs/语言参考/预定义变量/$_SERVER.html)
  * [$_ENV](/docs/语言参考/预定义变量/$_ENV.html)
  * [$http_response_header](/docs/语言参考/预定义变量/$http_response_header.html)
  * [$argc](/docs/语言参考/预定义变量/$argc.html)
  * [$argv](/docs/语言参考/预定义变量/$argv.html)
* [预定义异常](/docs/语言参考/预定义异常.html)
  * [Exception](/docs/语言参考/预定义异常/Exception.html)
  * [ErrorException](/docs/语言参考/预定义异常/ErrorException.html)
* [预定义接口](/docs/语言参考/预定义接口.html)
  * [Traversable](/docs/语言参考/预定义接口/Traversable.html)
  * [Iterator](/docs/语言参考/预定义接口/Iterator.html)
  * [IteratorAggregate](/docs/语言参考/预定义接口/IteratorAggregate.html)
  * [ArrayAccess](/docs/语言参考/预定义接口/ArrayAccess.html)
  * [Serializable](/docs/语言参考/预定义接口/Serializable.html)
  * [Closure](/docs/语言参考/预定义接口/Closure.html)
  * [Generator](/docs/语言参考/预定义接口/Generator.html)
* [上下文选项和参数](/docs/语言参考/上下文选项和参数.html)
  * [套接字上下文选项](/docs/语言参考/上下文选项和参数/套接字上下文选项.html)
  * [HTTP 上下文选项](/docs/语言参考/上下文选项和参数/HTTP 上下文选项.html)
  * [FTP 上下文选项](/docs/语言参考/上下文选项和参数/FTP 上下文选项.html)
  * [SSL 上下文选项](/docs/语言参考/上下文选项和参数/SSL 上下文选项.html)
  * [CURL 上下文选项](/docs/语言参考/上下文选项和参数/CURL 上下文选项.html)
  * [Phar 上下文选项](/docs/语言参考/上下文选项和参数/Phar 上下文选项.html)
  * [MongoDB 上下文选项](/docs/语言参考/上下文选项和参数/MongoDB 上下文选项.html)
  * [Context 参数](/docs/语言参考/上下文选项和参数/Context 参数.html)
* [支持的协议和封装协议](/docs/语言参考/支持的协议和封装协议.html)
  * [file://](/docs/语言参考/支持的协议和封装协议/file.html)
  * [http://](/docs/语言参考/支持的协议和封装协议/http.html)
  * [ftp://](/docs/语言参考/支持的协议和封装协议/ftp.html)
  * [php://](/docs/语言参考/支持的协议和封装协议/php.html)
  * [zlib://](/docs/语言参考/支持的协议和封装协议/zlib.html)
  * [data://](/docs/语言参考/支持的协议和封装协议/data.html)
  * [global://](/docs/语言参考/支持的协议和封装协议/global.html)
  * [phar://](/docs/语言参考/支持的协议和封装协议/phar.html)
  * [ssh2://](/docs/语言参考/支持的协议和封装协议/ssh2.html)
  * [rar://](/docs/语言参考/支持的协议和封装协议/rar.html)
  * [ogg://](/docs/语言参考/支持的协议和封装协议/ogg.html)
  * [expect://](/docs/语言参考/支持的协议和封装协议/expect.html)

