# 用户自定义函数

任何有效的 PHP 代码都有可能出现在函数内部，甚至包括其它函数和类定义。函数名和 PHP 中的其它标识符命名规则相同。有效的函数名以字母或下划线打头，后面跟字母，数字或下划线。

```php
<?php

foo();

/**
 * Just a test function.
 *
 * @param  void
 * @return void
 */
function foo()
{
    //
}

```

函数无需在调用之前被定义，除非函数是有条件被定义的。当一个函数是有条件被定义时，必须在调用函数之前定义。

```php
<?php

foo();

/**
 * Just a test function.
 *
 * @param  void
 * @return void
 */
function foo()
{
    //
}

if (true) {
    /**
     * Just a test function.
     *
     * @param  void
     * @return void
     */
    function bar()
    {
        //
    }
}

bar();

```

函数中的函数。

```php
<?php

/**
 * Just a test function.
 *
 * @param  void
 * @return void
 */
function foo()
{
    /**
     * Just a test function.
     *
     * @param  void
     * @return void
     */
    function bar()
    {
        //
    }
}

foo();
bar();

```

递归函数。

```php
<?php

/**
 * Recursive function.
 *
 * @param  int    $number
 * @return void
 */
function foo(int $number)
{
    if ($number < 10) {
        foo($number + 1);
    }
}

foo(1);

```

