# 赋值运算符

基本的赋值运算符是 `=` 。它意味着把右边表达式的值赋给左边的运算数。注意赋值运算将原变量的值拷贝到新变量中（传值赋值），所以改变其中一个并不影响另一个。在 PHP 中普通的传值赋值行为有个例外就是碰到对象时，在 PHP 中是以引用赋值的。

```php
<?php

$bar = ($foo = 4) + 5;
var_dump($foo); // int(4)
var_dump($bar); // int(9)

```

PHP 支持引用赋值，引用赋值意味着两个变量指向了同一个数据，没有拷贝任何东西。

```php
<?php

$foo = 4;
$bar = &$foo;
var_dump($foo); // int(4)
var_dump($bar); // int(4)

$foo = 5;
var_dump($foo); // int(5)
var_dump($bar); // int(5)

```

